]> git.notmuchmail.org Git - notmuch/blob - test/test-lib.sh
test: remove --root option and fix TMP_DIRECTORY cleanup
[notmuch] / test / test-lib.sh
1 #
2 # Copyright (c) 2005 Junio C Hamano
3 # Copyright (c) 2010 Notmuch Developers
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see https://www.gnu.org/licenses/ .
17
18 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
19     echo "Error: The notmuch test suite requires a bash version >= 4.0"
20     echo "due to use of associative arrays within the test suite."
21     echo "Please try again with a newer bash (or help us fix the"
22     echo "test suite to be more portable). Thanks."
23     exit 1
24 fi
25
26 # Make sure echo builtin does not expand backslash-escape sequences by default.
27 shopt -u xpg_echo
28
29 # Ensure NOTMUCH_SRCDIR and NOTMUCH_BUILDDIR are set.
30 . $(dirname "$0")/export-dirs.sh || exit 1
31
32 # It appears that people try to run tests without building...
33 if [[ ! -x "$NOTMUCH_BUILDDIR/notmuch" ]]; then
34         echo >&2 'You do not seem to have built notmuch yet.'
35         exit 1
36 fi
37
38 this_test=${0##*/}
39 this_test=${this_test%.sh}
40 this_test_bare=${this_test#T[0-9][0-9][0-9]-}
41
42 # if --tee was passed, write the output not only to the terminal, but
43 # additionally to the file test-results/$BASENAME.out, too.
44 case "$GIT_TEST_TEE_STARTED, $* " in
45 done,*)
46         # do not redirect again
47         ;;
48 *' --tee '*|*' --va'*)
49         mkdir -p test-results
50         BASE=test-results/$this_test
51         (GIT_TEST_TEE_STARTED=done "$BASH" "$0" "$@" 2>&1;
52          echo $? > $BASE.exit) | tee $BASE.out
53         test "$(cat $BASE.exit)" = 0
54         exit
55         ;;
56 esac
57
58 # Save STDOUT to fd 6 and STDERR to fd 7.
59 exec 6>&1 7>&2
60 # Make xtrace debugging (when used) use redirected STDERR, with verbose lead:
61 BASH_XTRACEFD=7
62 export PS4='+(${BASH_SOURCE}:${LINENO}): ${FUNCNAME[0]:+${FUNCNAME[0]}(): }'
63
64 # Keep the original TERM for say_color and test_emacs
65 ORIGINAL_TERM=$TERM
66
67 # Set SMART_TERM to vt100 for known dumb/unknown terminal.
68 # Otherwise use whatever TERM is currently used so that
69 # users' actual TERM environments are being used in tests.
70 case ${TERM-} in
71         '' | dumb | unknown )
72                 SMART_TERM=vt100 ;;
73         *)
74                 SMART_TERM=$TERM ;;
75 esac
76
77 # For repeatability, reset the environment to known value.
78 LANG=C
79 LC_ALL=C
80 PAGER=cat
81 TZ=UTC
82 TERM=dumb
83 export LANG LC_ALL PAGER TERM TZ
84 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
85 if [[ ( -n "$TEST_EMACS" && -z "$TEST_EMACSCLIENT" ) || \
86       ( -z "$TEST_EMACS" && -n "$TEST_EMACSCLIENT" ) ]]; then
87     echo "error: must specify both or neither of TEST_EMACS and TEST_EMACSCLIENT" >&2
88     exit 1
89 fi
90 TEST_EMACS=${TEST_EMACS:-${EMACS:-emacs}}
91 TEST_EMACSCLIENT=${TEST_EMACSCLIENT:-emacsclient}
92 TEST_GDB=${TEST_GDB:-gdb}
93 TEST_CC=${TEST_CC:-cc}
94 TEST_CFLAGS=${TEST_CFLAGS:-"-g -O0"}
95
96 # Protect ourselves from common misconfiguration to export
97 # CDPATH into the environment
98 unset CDPATH
99
100 unset GREP_OPTIONS
101
102 # For emacsclient
103 unset ALTERNATE_EDITOR
104
105 add_gnupg_home ()
106 {
107     local output
108     [ -d ${GNUPGHOME} ] && return
109     _gnupg_exit () { gpgconf --kill all 2>/dev/null || true; }
110     at_exit_function _gnupg_exit
111     mkdir -m 0700 "$GNUPGHOME"
112     gpg --no-tty --import <$TEST_DIRECTORY/gnupg-secret-key.asc >"$GNUPGHOME"/import.log 2>&1
113     test_debug "cat $GNUPGHOME/import.log"
114     if (gpg --quick-random --version >/dev/null 2>&1) ; then
115         echo quick-random >> "$GNUPGHOME"/gpg.conf
116     elif (gpg --debug-quick-random --version >/dev/null 2>&1) ; then
117         echo debug-quick-random >> "$GNUPGHOME"/gpg.conf
118     fi
119     echo no-emit-version >> "$GNUPGHOME"/gpg.conf
120 }
121
122 # Each test should start with something like this, after copyright notices:
123 #
124 # test_description='Description of this test...
125 # This test checks if command xyzzy does the right thing...
126 # '
127 # . ./test-lib.sh || exit 1
128
129 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
130                 TERM=$ORIGINAL_TERM &&
131                 export TERM &&
132                 [ -t 1 ] &&
133                 tput bold >/dev/null 2>&1 &&
134                 tput setaf 1 >/dev/null 2>&1 &&
135                 tput sgr0 >/dev/null 2>&1
136         ) &&
137         color=t
138
139 while test "$#" -ne 0
140 do
141         case "$1" in
142         -d|--debug)
143                 debug=t; shift ;;
144         -i|--immediate)
145                 immediate=t; shift ;;
146         -h|--help)
147                 help=t; shift ;;
148         -v|--verbose)
149                 verbose=t; shift ;;
150         -q|--quiet)
151                 quiet=t; shift ;;
152         --with-dashes)
153                 with_dashes=t; shift ;;
154         --no-color)
155                 color=; shift ;;
156         --no-python)
157                 # noop now...
158                 shift ;;
159         --valgrind)
160                 valgrind=t; verbose=t; shift ;;
161         --tee)
162                 shift ;; # was handled already
163         *)
164                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
165         esac
166 done
167
168 if test -n "$debug"; then
169     print_subtest () {
170         printf " %-4s" "[$((test_count - 1))]"
171     }
172 else
173     print_subtest () {
174         true
175     }
176 fi
177
178 if test -n "$color"; then
179         say_color () {
180                 (
181                 TERM=$ORIGINAL_TERM
182                 export TERM
183                 case "$1" in
184                         error) tput bold; tput setaf 1;; # bold red
185                         skip)  tput bold; tput setaf 2;; # bold green
186                         pass)  tput setaf 2;;            # green
187                         info)  tput setaf 3;;            # brown
188                         *) test -n "$quiet" && return;;
189                 esac
190                 shift
191                 printf " "
192                 printf "$@"
193                 tput sgr0
194                 print_subtest
195                 )
196         }
197 else
198         say_color() {
199                 test -z "$1" && test -n "$quiet" && return
200                 shift
201                 printf " "
202                 printf "$@"
203                 print_subtest
204         }
205 fi
206
207 error () {
208         say_color error "error: $*\n"
209         GIT_EXIT_OK=t
210         exit 1
211 }
212
213 say () {
214         say_color info "$*"
215 }
216
217 test "${test_description}" != "" ||
218 error "Test script did not set test_description."
219
220 if test "$help" = "t"
221 then
222         echo "Tests ${test_description}"
223         exit 0
224 fi
225
226 test_description_printed=
227 print_test_description ()
228 {
229         test -z "$test_description_printed" || return 0
230         echo
231         echo $this_test: "Testing ${test_description}"
232         test_description_printed=1
233 }
234 if [ -z "$NOTMUCH_TEST_QUIET" ]
235 then
236         print_test_description
237 fi
238
239 test_failure=0
240 test_count=0
241 test_fixed=0
242 test_broken=0
243 test_success=0
244
245 declare -a _exit_functions=()
246
247 at_exit_function () {
248         _exit_functions=($1 ${_exit_functions[@]/$1})
249 }
250
251 rm_exit_function () {
252         _exit_functions=(${_exit_functions[@]/$1})
253 }
254
255 _exit_common () {
256         code=$?
257         trap - EXIT
258         set +ex
259         for _fn in ${_exit_functions[@]}; do $_fn; done
260         rm -rf "$TEST_TMPDIR"
261 }
262
263 trap_exit () {
264         _exit_common
265         if test -n "$GIT_EXIT_OK"
266         then
267                 exit $code
268         else
269                 exec >&6
270                 say_color error '%-6s' FATAL
271                 echo " $test_subtest_name"
272                 echo
273                 echo "Unexpected exit while executing $0. Exit code $code."
274                 exit 1
275         fi
276 }
277
278 trap_signal () {
279         _exit_common
280         echo >&6 "FATAL: $0: interrupted by signal" $((code - 128))
281         exit $code
282 }
283
284 die () {
285         _exit_common
286         exec >&6
287         say_color error '%-6s' FATAL
288         echo " $*"
289         echo
290         echo "Unexpected exit while executing $0."
291         exit 1
292 }
293
294 GIT_EXIT_OK=
295 # Note: TEST_TMPDIR *NOT* exported!
296 TEST_TMPDIR=$(mktemp -d "${TMPDIR:-/tmp}/notmuch-test-$$.XXXXXX")
297 # Put GNUPGHOME in TMPDIR to avoid problems with long paths.
298 export GNUPGHOME="${TEST_TMPDIR}/gnupg"
299 trap 'trap_exit' EXIT
300 trap 'trap_signal' HUP INT TERM
301
302 # Deliver a message with emacs and add it to the database
303 #
304 # Uses emacs to generate and deliver a message to the mail store.
305 # Accepts arbitrary extra emacs/elisp functions to modify the message
306 # before sending, which is useful to doing things like attaching files
307 # to the message and encrypting/signing.
308 emacs_deliver_message ()
309 {
310     local subject="$1"
311     local body="$2"
312     shift 2
313     # before we can send a message, we have to prepare the FCC maildir
314     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
315     # eval'ing smtp-dummy --background will set smtp_dummy_pid
316     smtp_dummy_pid=
317     eval `$TEST_DIRECTORY/smtp-dummy --background sent_message`
318     test -n "$smtp_dummy_pid" || return 1
319
320     test_emacs \
321         "(let ((message-send-mail-function 'message-smtpmail-send-it)
322                (mail-host-address \"example.com\")
323                (smtpmail-smtp-server \"localhost\")
324                (smtpmail-smtp-service \"25025\"))
325            (notmuch-mua-mail)
326            (message-goto-to)
327            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
328            (message-goto-subject)
329            (insert \"${subject}\")
330            (message-goto-body)
331            (insert \"${body}\")
332            $@
333            (notmuch-mua-send-and-exit))"
334
335     # In case message was sent properly, client waits for confirmation
336     # before exiting and resuming control here; therefore making sure
337     # that server exits by sending (KILL) signal to it is safe.
338     kill -9 $smtp_dummy_pid
339     notmuch new >/dev/null
340 }
341
342 # Pretend to deliver a message with emacs. Really save it to a file
343 # and add it to the database
344 #
345 # Uses emacs to generate and deliver a message to the mail store.
346 # Accepts arbitrary extra emacs/elisp functions to modify the message
347 # before sending, which is useful to doing things like attaching files
348 # to the message and encrypting/signing.
349 emacs_fcc_message ()
350 {
351     local subject="$1"
352     local body="$2"
353     shift 2
354     # before we can send a message, we have to prepare the FCC maildir
355     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
356
357     test_emacs \
358         "(let ((message-send-mail-function (lambda () t))
359                (mail-host-address \"example.com\"))
360            (notmuch-mua-mail)
361            (message-goto-to)
362            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
363            (message-goto-subject)
364            (insert \"${subject}\")
365            (message-goto-body)
366            (insert \"${body}\")
367            $@
368            (notmuch-mua-send-and-exit))" || return 1
369     notmuch new >/dev/null
370 }
371
372 # Add an existing, fixed corpus of email to the database.
373 #
374 # $1 is the corpus dir under corpora to add, using "default" if unset.
375 #
376 # The default corpus is based on about 50 messages from early in the
377 # history of the notmuch mailing list, which allows for reliably
378 # testing commands that need to operate on a not-totally-trivial
379 # number of messages.
380 add_email_corpus ()
381 {
382     corpus=${1:-default}
383
384     rm -rf ${MAIL_DIR}
385     if [ -d $TEST_DIRECTORY/corpora.mail/$corpus ]; then
386         cp -a $TEST_DIRECTORY/corpora.mail/$corpus ${MAIL_DIR}
387     else
388         cp -a $NOTMUCH_SRCDIR/test/corpora/$corpus ${MAIL_DIR}
389         notmuch new >/dev/null || die "'notmuch new' failed while adding email corpus"
390         mkdir -p $TEST_DIRECTORY/corpora.mail
391         cp -a ${MAIL_DIR} $TEST_DIRECTORY/corpora.mail/$corpus
392     fi
393 }
394
395 test_begin_subtest ()
396 {
397     if [ -n "$inside_subtest" ]; then
398         exec 1>&6 2>&7          # Restore stdout and stderr
399         error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
400     fi
401     test_subtest_name="$1"
402     test_reset_state_
403     # Redirect test output to the previously prepared file descriptors
404     # 3 and 4 (see below)
405     if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
406     exec >&3 2>&4
407     inside_subtest=t
408 }
409
410 # Pass test if two arguments match
411 #
412 # Note: Unlike all other test_expect_* functions, this function does
413 # not accept a test name. Instead, the caller should call
414 # test_begin_subtest before calling this function in order to set the
415 # name.
416 test_expect_equal ()
417 {
418         exec 1>&6 2>&7          # Restore stdout and stderr
419         if [ -z "$inside_subtest" ]; then
420                 error "bug in the test script: test_expect_equal without test_begin_subtest"
421         fi
422         inside_subtest=
423         test "$#" = 2 ||
424         error "bug in the test script: not 2 parameters to test_expect_equal"
425
426         output="$1"
427         expected="$2"
428         if ! test_skip "$test_subtest_name"
429         then
430                 if [ "$output" = "$expected" ]; then
431                         test_ok_
432                 else
433                         testname=$this_test.$test_count
434                         echo "$expected" > $testname.expected
435                         echo "$output" > $testname.output
436                         test_failure_ "$(diff -u $testname.expected $testname.output)"
437                 fi
438     fi
439 }
440
441 # Like test_expect_equal, but takes two filenames.
442 test_expect_equal_file ()
443 {
444         exec 1>&6 2>&7          # Restore stdout and stderr
445         if [ -z "$inside_subtest" ]; then
446                 error "bug in the test script: test_expect_equal_file without test_begin_subtest"
447         fi
448         inside_subtest=
449         test "$#" = 2 ||
450         error "bug in the test script: not 2 parameters to test_expect_equal_file"
451
452         file1="$1"
453         file2="$2"
454         if ! test_skip "$test_subtest_name"
455         then
456                 if diff -q "$file1" "$file2" >/dev/null ; then
457                         test_ok_
458                 else
459                         testname=$this_test.$test_count
460                         basename1=`basename "$file1"`
461                         basename2=`basename "$file2"`
462                         cp "$file1" "$testname.$basename1"
463                         cp "$file2" "$testname.$basename2"
464                         test_failure_ "$(diff -u "$testname.$basename1" "$testname.$basename2")"
465                 fi
466     fi
467 }
468
469 # Like test_expect_equal, but arguments are JSON expressions to be
470 # canonicalized before diff'ing.  If an argument cannot be parsed, it
471 # is used unchanged so that there's something to diff against.
472 test_expect_equal_json () {
473     # The test suite forces LC_ALL=C, but this causes Python 3 to
474     # decode stdin as ASCII.  We need to read JSON in UTF-8, so
475     # override Python's stdio encoding defaults.
476     local script='import json, sys; json.dump(json.load(sys.stdin), sys.stdout, sort_keys=True, indent=4)'
477     output=$(echo "$1" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
478         || echo "$1")
479     expected=$(echo "$2" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
480         || echo "$2")
481     shift 2
482     test_expect_equal "$output" "$expected" "$@"
483 }
484
485 # Sort the top-level list of JSON data from stdin.
486 test_sort_json () {
487     PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c \
488         "import sys, json; json.dump(sorted(json.load(sys.stdin)),sys.stdout)"
489 }
490
491 test_emacs_expect_t () {
492         test "$#" = 1 ||
493         error "bug in the test script: not 1 parameter to test_emacs_expect_t"
494         if [ -z "$inside_subtest" ]; then
495                 error "bug in the test script: test_emacs_expect_t without test_begin_subtest"
496         fi
497
498         # Run the test.
499         if ! test_skip "$test_subtest_name"
500         then
501                 test_emacs "(notmuch-test-run $1)" >/dev/null
502
503                 # Restore state after the test.
504                 exec 1>&6 2>&7          # Restore stdout and stderr
505                 inside_subtest=
506
507                 # Report success/failure.
508                 result=$(cat OUTPUT)
509                 if [ "$result" = t ]
510                 then
511                         test_ok_
512                 else
513                         test_failure_ "${result}"
514                 fi
515         else
516                 # Restore state after the (non) test.
517                 exec 1>&6 2>&7          # Restore stdout and stderr
518                 inside_subtest=
519         fi
520 }
521
522 NOTMUCH_NEW ()
523 {
524     notmuch new "${@}" | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
525 }
526
527 NOTMUCH_DUMP_TAGS ()
528 {
529     # this relies on the default format being batch-tag, otherwise some tests will break
530     notmuch dump --include=tags "${@}" | sed '/^#/d' | sort
531 }
532
533 notmuch_drop_mail_headers ()
534 {
535     $NOTMUCH_PYTHON -c '
536 import email, sys
537 msg = email.message_from_file(sys.stdin)
538 for hdr in sys.argv[1:]: del msg[hdr]
539 print(msg.as_string(False))
540 ' "$@"
541 }
542
543 notmuch_search_sanitize ()
544 {
545     perl -pe 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
546 }
547
548 notmuch_search_files_sanitize ()
549 {
550     notmuch_dir_sanitize
551 }
552
553 notmuch_dir_sanitize ()
554 {
555     sed -e "s,$MAIL_DIR,MAIL_DIR," -e "s,${PWD},CWD,g" "$@"
556 }
557
558 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
559 notmuch_show_sanitize ()
560 {
561     sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
562 }
563 notmuch_show_sanitize_all ()
564 {
565     sed \
566         -e 's| filename:.*| filename:XXXXX|' \
567         -e 's| id:[^ ]* | id:XXXXX |' | \
568         notmuch_date_sanitize
569 }
570
571 notmuch_json_show_sanitize ()
572 {
573     sed \
574         -e 's|"id": "[^"]*",|"id": "XXXXX",|g' \
575         -e 's|"Date": "Fri, 05 Jan 2001 [^"]*0000"|"Date": "GENERATED_DATE"|g' \
576         -e 's|"filename": "signature.asc",||g' \
577         -e 's|"filename": \["/[^"]*"\],|"filename": \["YYYYY"\],|g' \
578         -e 's|"timestamp": 97.......|"timestamp": 42|g' \
579         -e 's|"content-length": [1-9][0-9]*|"content-length": "NONZERO"|g'
580 }
581
582 notmuch_emacs_error_sanitize ()
583 {
584     local command=$1
585     shift
586     for file in "$@"; do
587         echo "=== $file ==="
588         cat "$file"
589     done | sed  \
590         -e 's/^\[.*\]$/[XXX]/' \
591         -e "s|^\(command: \)\{0,1\}/.*/$command|\1YYY/$command|"
592 }
593
594 notmuch_date_sanitize ()
595 {
596     sed \
597         -e 's/^Date: Fri, 05 Jan 2001 .*0000/Date: GENERATED_DATE/'
598 }
599
600 notmuch_uuid_sanitize ()
601 {
602     sed 's/[0-9a-f]\{8\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{12\}/UUID/g'
603 }
604
605 notmuch_built_with_sanitize ()
606 {
607     sed 's/^built_with[.]\(.*\)=.*$/built_with.\1=something/'
608 }
609
610 notmuch_config_sanitize ()
611 {
612     notmuch_dir_sanitize | notmuch_built_with_sanitize
613 }
614
615 # End of notmuch helper functions
616
617 # Use test_set_prereq to tell that a particular prerequisite is available.
618 #
619 # The prerequisite can later be checked for by using test_have_prereq.
620 #
621 # The single parameter is the prerequisite tag (a simple word, in all
622 # capital letters by convention).
623
624 test_set_prereq () {
625         satisfied="$satisfied$1 "
626 }
627 satisfied=" "
628
629 test_have_prereq () {
630         case $satisfied in
631         *" $1 "*)
632                 : yes, have it ;;
633         *)
634                 ! : nope ;;
635         esac
636 }
637
638 declare -A test_missing_external_prereq_
639 declare -A test_subtest_missing_external_prereq_
640
641 # declare prerequisite for the given external binary
642 test_declare_external_prereq () {
643         binary="$1"
644         test "$#" = 2 && name=$2 || name="$binary(1)"
645
646         if ! hash $binary 2>/dev/null; then
647                 test_missing_external_prereq_["${binary}"]=t
648                 eval "
649 $binary () {
650         test_subtest_missing_external_prereq_[\"${name}\"]=t
651         false
652 }"
653         fi
654 }
655
656 # Explicitly require external prerequisite.  Useful when binary is
657 # called indirectly (e.g. from emacs).
658 # Returns success if dependency is available, failure otherwise.
659 test_require_external_prereq () {
660         binary="$1"
661         if [[ ${test_missing_external_prereq_["${binary}"]} == t ]]; then
662                 # dependency is missing, call the replacement function to note it
663                 eval "$binary"
664         else
665                 true
666         fi
667 }
668
669 # You are not expected to call test_ok_ and test_failure_ directly, use
670 # the text_expect_* functions instead.
671
672 test_ok_ () {
673         if test "$test_subtest_known_broken_" = "t"; then
674                 test_known_broken_ok_
675                 return
676         fi
677         test_success=$(($test_success + 1))
678         if test -n "$NOTMUCH_TEST_QUIET"; then
679                 return 0
680         fi
681         say_color pass "%-6s" "PASS"
682         echo " $test_subtest_name"
683 }
684
685 test_failure_ () {
686         print_test_description
687         if test "$test_subtest_known_broken_" = "t"; then
688                 test_known_broken_failure_ "$@"
689                 return
690         fi
691         test_failure=$(($test_failure + 1))
692         test_failure_message_ "FAIL" "$test_subtest_name" "$@"
693         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
694         return 1
695 }
696
697 test_failure_message_ () {
698         say_color error "%-6s" "$1"
699         echo " $2"
700         shift 2
701         if [ "$#" != "0" ]; then
702                 echo "$@" | sed -e 's/^/        /'
703         fi
704         if test "$verbose" != "t"; then cat test.output; fi
705 }
706
707 test_known_broken_ok_ () {
708         test_reset_state_
709         test_fixed=$(($test_fixed+1))
710         say_color pass "%-6s" "FIXED"
711         echo " $test_subtest_name"
712 }
713
714 test_known_broken_failure_ () {
715         test_reset_state_
716         test_broken=$(($test_broken+1))
717         if [ -z "$NOTMUCH_TEST_QUIET" ]; then
718                 test_failure_message_ "BROKEN" "$test_subtest_name" "$@"
719         else
720                 test_failure_message_ "BROKEN" "$test_subtest_name"
721         fi
722         return 1
723 }
724
725 test_debug () {
726         test "$debug" = "" || eval "$1"
727 }
728
729 test_run_ () {
730         test_cleanup=:
731         if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
732         eval >&3 2>&4 "$1"
733         eval_ret=$?
734         eval >&3 2>&4 "$test_cleanup"
735         return 0
736 }
737
738 test_skip () {
739         test_count=$(($test_count+1))
740         to_skip=
741         for skp in $NOTMUCH_SKIP_TESTS
742         do
743                 case $this_test.$test_count in
744                 $skp)
745                         to_skip=t
746                         break
747                 esac
748                 case $this_test_bare.$test_count in
749                 $skp)
750                         to_skip=t
751                         break
752                 esac
753         done
754         case "$to_skip" in
755         t)
756                 test_report_skip_ "$@"
757                 ;;
758         *)
759                 test_check_missing_external_prereqs_ "$@"
760                 ;;
761         esac
762 }
763
764 test_check_missing_external_prereqs_ () {
765         if [[ ${#test_subtest_missing_external_prereq_[@]} != 0 ]]; then
766                 say_color skip >&1 "missing prerequisites: "
767                 echo ${!test_subtest_missing_external_prereq_[@]} >&1
768                 test_report_skip_ "$@"
769         else
770                 false
771         fi
772 }
773
774 test_report_skip_ () {
775         test_reset_state_
776         say_color skip >&3 "skipping test:"
777         echo " $@" >&3
778         say_color skip "%-6s" "SKIP"
779         echo " $1"
780 }
781
782 test_subtest_known_broken () {
783         test_subtest_known_broken_=t
784 }
785
786 test_expect_success () {
787         exec 1>&6 2>&7          # Restore stdout and stderr
788         if [ -z "$inside_subtest" ]; then
789                 error "bug in the test script: test_expect_success without test_begin_subtest"
790         fi
791         inside_subtest=
792         test "$#" = 1 ||
793         error "bug in the test script: not 1 parameters to test_expect_success"
794
795         if ! test_skip "$test_subtest_name"
796         then
797                 test_run_ "$1"
798                 run_ret="$?"
799                 # test_run_ may update missing external prerequisites
800                 test_check_missing_external_prereqs_ "$@" ||
801                 if [ "$run_ret" = 0 -a "$eval_ret" = 0 ]
802                 then
803                         test_ok_
804                 else
805                         test_failure_ "$1"
806                 fi
807         fi
808 }
809
810 test_expect_code () {
811         exec 1>&6 2>&7          # Restore stdout and stderr
812         if [ -z "$inside_subtest" ]; then
813                 error "bug in the test script: test_expect_code without test_begin_subtest"
814         fi
815         inside_subtest=
816         test "$#" = 2 ||
817         error "bug in the test script: not 2 parameters to test_expect_code"
818
819         if ! test_skip "$test_subtest_name"
820         then
821                 test_run_ "$2"
822                 run_ret="$?"
823                 # test_run_ may update missing external prerequisites,
824                 test_check_missing_external_prereqs_ "$@" ||
825                 if [ "$run_ret" = 0 -a "$eval_ret" = "$1" ]
826                 then
827                         test_ok_
828                 else
829                         test_failure_ "exit code $eval_ret, expected $1" "$2"
830                 fi
831         fi
832 }
833
834 # This is not among top-level (test_expect_success)
835 # but is a prefix that can be used in the test script, like:
836 #
837 #       test_expect_success 'complain and die' '
838 #           do something &&
839 #           do something else &&
840 #           test_must_fail git checkout ../outerspace
841 #       '
842 #
843 # Writing this as "! git checkout ../outerspace" is wrong, because
844 # the failure could be due to a segv.  We want a controlled failure.
845
846 test_must_fail () {
847         "$@"
848         test $? -gt 0 -a $? -le 129 -o $? -gt 192
849 }
850
851 # test_cmp is a helper function to compare actual and expected output.
852 # You can use it like:
853 #
854 #       test_expect_success 'foo works' '
855 #               echo expected >expected &&
856 #               foo >actual &&
857 #               test_cmp expected actual
858 #       '
859 #
860 # This could be written as either "cmp" or "diff -u", but:
861 # - cmp's output is not nearly as easy to read as diff -u
862 # - not all diff versions understand "-u"
863
864 test_cmp() {
865         $GIT_TEST_CMP "$@"
866 }
867
868 # This function can be used to schedule some commands to be run
869 # unconditionally at the end of the test to restore sanity:
870 #
871 #       test_expect_success 'test core.capslock' '
872 #               git config core.capslock true &&
873 #               test_when_finished "git config --unset core.capslock" &&
874 #               hello world
875 #       '
876 #
877 # That would be roughly equivalent to
878 #
879 #       test_expect_success 'test core.capslock' '
880 #               git config core.capslock true &&
881 #               hello world
882 #               git config --unset core.capslock
883 #       '
884 #
885 # except that the greeting and config --unset must both succeed for
886 # the test to pass.
887
888 test_when_finished () {
889         test_cleanup="{ $*
890                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
891 }
892
893 test_done () {
894         GIT_EXIT_OK=t
895         test_results_dir="$TEST_DIRECTORY/test-results"
896         mkdir -p "$test_results_dir"
897         test_results_path="$test_results_dir/$this_test"
898
899         echo "total $test_count" >> $test_results_path
900         echo "success $test_success" >> $test_results_path
901         echo "fixed $test_fixed" >> $test_results_path
902         echo "broken $test_broken" >> $test_results_path
903         echo "failed $test_failure" >> $test_results_path
904         echo "" >> $test_results_path
905
906         [ -n "$EMACS_SERVER" ] && test_emacs '(kill-emacs)'
907
908         if [ "$test_failure" = "0" ]; then
909             if [ "$test_broken" = "0" ]; then
910                 rm -rf "$remove_tmp"
911             fi
912             exit 0
913         else
914             exit 1
915         fi
916 }
917
918 emacs_generate_script () {
919         # Construct a little test script here for the benefit of the user,
920         # (who can easily run "run_emacs" to get the same emacs environment
921         # for investigating any failures).
922         cat <<EOF >"$TMP_DIRECTORY/run_emacs"
923 #!/bin/sh
924 export PATH=$PATH
925 export NOTMUCH_CONFIG=$NOTMUCH_CONFIG
926
927 # Here's what we are using here:
928 #
929 # --quick              Use minimal customization. This implies --no-init-file,
930 #                      --no-site-file and (emacs 24) --no-site-lisp
931 #
932 # --directory           Ensure that the local elisp sources are found
933 #
934 # --load                Force loading of notmuch.el and test-lib.el
935
936 exec ${TEST_EMACS} --quick \
937         --directory "$NOTMUCH_SRCDIR/emacs" --load notmuch.el \
938         --directory "$NOTMUCH_SRCDIR/test" --load test-lib.el \
939         "\$@"
940 EOF
941         chmod a+x "$TMP_DIRECTORY/run_emacs"
942 }
943
944 test_emacs () {
945         # test dependencies beforehand to avoid the waiting loop below
946         missing_dependencies=
947         test_require_external_prereq dtach || missing_dependencies=1
948         test_require_external_prereq emacs || missing_dependencies=1
949         test_require_external_prereq ${TEST_EMACSCLIENT} || missing_dependencies=1
950         test -z "$missing_dependencies" || return
951
952         if [ -z "$EMACS_SERVER" ]; then
953                 emacs_tests="$NOTMUCH_SRCDIR/test/${this_test_bare}.el"
954                 if [ -f "$emacs_tests" ]; then
955                         load_emacs_tests="--eval '(load \"$emacs_tests\")'"
956                 else
957                         load_emacs_tests=
958                 fi
959                 server_name="notmuch-test-suite-$$"
960                 # start a detached session with an emacs server
961                 # user's TERM (or 'vt100' in case user's TERM is known dumb
962                 # or unknown) is given to dtach which assumes a minimally
963                 # VT100-compatible terminal -- and emacs inherits that
964                 TERM=$SMART_TERM dtach -n "$TEST_TMPDIR/emacs-dtach-socket.$$" \
965                         sh -c "stty rows 24 cols 80; exec '$TMP_DIRECTORY/run_emacs' \
966                                 --no-window-system \
967                                 $load_emacs_tests \
968                                 --eval '(setq server-name \"$server_name\")' \
969                                 --eval '(server-start)' \
970                                 --eval '(orphan-watchdog $$)'" || return
971                 EMACS_SERVER="$server_name"
972                 # wait until the emacs server is up
973                 until test_emacs '()' >/dev/null 2>/dev/null; do
974                         sleep 1
975                 done
976         fi
977
978         # Clear test-output output file.  Most Emacs tests end with a
979         # call to (test-output).  If the test code fails with an
980         # exception before this call, the output file won't get
981         # updated.  Since we don't want to compare against an output
982         # file from another test, so start out with an empty file.
983         rm -f OUTPUT
984         touch OUTPUT
985
986         ${TEST_EMACSCLIENT} --socket-name="$EMACS_SERVER" --eval "(notmuch-test-progn $@)"
987 }
988
989 test_python() {
990     # Note: if there is need to print debug information from python program,
991     # use stdout = os.fdopen(6, 'w') or stderr = os.fdopen(7, 'w')
992     PYTHONPATH="$NOTMUCH_SRCDIR/bindings/python${PYTHONPATH:+:$PYTHONPATH}" \
993         $NOTMUCH_PYTHON -B - > OUTPUT
994 }
995
996 test_ruby() {
997     MAIL_DIR=$MAIL_DIR ruby -I $NOTMUCH_SRCDIR/bindings/ruby> OUTPUT
998 }
999
1000 test_C () {
1001     exec_file="test${test_count}"
1002     test_file="${exec_file}.c"
1003     cat > ${test_file}
1004     ${TEST_CC} ${TEST_CFLAGS} -I${NOTMUCH_SRCDIR}/test -I${NOTMUCH_SRCDIR}/lib -o ${exec_file} ${test_file} -L${NOTMUCH_BUILDDIR}/lib/ -lnotmuch -ltalloc
1005     echo "== stdout ==" > OUTPUT.stdout
1006     echo "== stderr ==" > OUTPUT.stderr
1007     ./${exec_file} "$@" 1>>OUTPUT.stdout 2>>OUTPUT.stderr
1008     notmuch_dir_sanitize OUTPUT.stdout OUTPUT.stderr > OUTPUT
1009 }
1010
1011
1012 # Creates a script that counts how much time it is executed and calls
1013 # notmuch.  $notmuch_counter_command is set to the path to the
1014 # generated script.  Use notmuch_counter_value() function to get the
1015 # current counter value.
1016 notmuch_counter_reset () {
1017         notmuch_counter_command="$TMP_DIRECTORY/notmuch_counter"
1018         if [ ! -x "$notmuch_counter_command" ]; then
1019                 notmuch_counter_state_path="$TMP_DIRECTORY/notmuch_counter.state"
1020                 cat >"$notmuch_counter_command" <<EOF || return
1021 #!/bin/sh
1022
1023 read count < "$notmuch_counter_state_path"
1024 echo \$((count + 1)) > "$notmuch_counter_state_path"
1025
1026 exec notmuch "\$@"
1027 EOF
1028                 chmod +x "$notmuch_counter_command" || return
1029         fi
1030
1031         echo 0 > "$notmuch_counter_state_path"
1032 }
1033
1034 # Returns the current notmuch counter value.
1035 notmuch_counter_value () {
1036         if [ -r "$notmuch_counter_state_path" ]; then
1037                 read count < "$notmuch_counter_state_path"
1038         else
1039                 count=0
1040         fi
1041         echo $count
1042 }
1043
1044 test_reset_state_ () {
1045         test -z "$test_init_done_" && test_init_
1046
1047         test_subtest_known_broken_=
1048         test_subtest_missing_external_prereq_=()
1049 }
1050
1051 # called once before the first subtest
1052 test_init_ () {
1053         test_init_done_=t
1054
1055         # skip all tests if there were external prerequisites missing during init
1056         test_check_missing_external_prereqs_ "all tests in $this_test" && test_done
1057 }
1058
1059
1060 . "$NOTMUCH_SRCDIR/test/test-lib-common.sh" || exit 1
1061
1062 if [ "${NOTMUCH_GMIME_MAJOR}" = 3 ]; then
1063     test_subtest_broken_gmime_3 () {
1064         test_subtest_known_broken
1065     }
1066     test_subtest_broken_gmime_2 () {
1067         true
1068     }
1069 else
1070     test_subtest_broken_gmime_3 () {
1071         true
1072     }
1073     test_subtest_broken_gmime_2 () {
1074         test_subtest_known_broken
1075     }
1076 fi
1077
1078 emacs_generate_script
1079
1080
1081 # Use -P to resolve symlinks in our working directory so that the cwd
1082 # in subprocesses like git equals our $PWD (for pathname comparisons).
1083 cd -P "$TMP_DIRECTORY" || error "Cannot set up test environment"
1084
1085 if test "$verbose" = "t"
1086 then
1087         exec 4>&2 3>&1
1088 else
1089         exec 4>test.output 3>&4
1090 fi
1091
1092 for skp in $NOTMUCH_SKIP_TESTS
1093 do
1094         to_skip=
1095         for skp in $NOTMUCH_SKIP_TESTS
1096         do
1097                 case "$this_test" in
1098                 $skp)
1099                         to_skip=t
1100                         break
1101                 esac
1102                 case "$this_test_bare" in
1103                 $skp)
1104                         to_skip=t
1105                         break
1106                 esac
1107         done
1108         case "$to_skip" in
1109         t)
1110                 say_color skip >&3 "skipping test $this_test altogether"
1111                 say_color skip "skip all tests in $this_test"
1112                 test_done
1113         esac
1114 done
1115
1116 # Provide an implementation of the 'yes' utility
1117 yes () {
1118         if test $# = 0
1119         then
1120                 y=y
1121         else
1122                 y="$*"
1123         fi
1124
1125         while echo "$y"
1126         do
1127                 :
1128         done
1129 }
1130
1131 # Fix some commands on Windows
1132 case $(uname -s) in
1133 *MINGW*)
1134         # Windows has its own (incompatible) sort and find
1135         sort () {
1136                 /usr/bin/sort "$@"
1137         }
1138         find () {
1139                 /usr/bin/find "$@"
1140         }
1141         sum () {
1142                 md5sum "$@"
1143         }
1144         # git sees Windows-style pwd
1145         pwd () {
1146                 builtin pwd -W
1147         }
1148         # no POSIX permissions
1149         # backslashes in pathspec are converted to '/'
1150         # exec does not inherit the PID
1151         ;;
1152 *)
1153         test_set_prereq POSIXPERM
1154         test_set_prereq BSLASHPSPEC
1155         test_set_prereq EXECKEEPSPID
1156         ;;
1157 esac
1158
1159 test -z "$NO_PERL" && test_set_prereq PERL
1160 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1161
1162 # test whether the filesystem supports symbolic links
1163 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1164 rm -f y
1165
1166 # convert variable from configure to more convenient form
1167 case "$NOTMUCH_DEFAULT_XAPIAN_BACKEND" in
1168     glass)
1169         db_ending=glass
1170     ;;
1171     chert)
1172         db_ending=DB
1173     ;;
1174     *)
1175         error "Unknown Xapian backend $NOTMUCH_DEFAULT_XAPIAN_BACKEND"
1176 esac
1177 # declare prerequisites for external binaries used in tests
1178 test_declare_external_prereq dtach
1179 test_declare_external_prereq emacs
1180 test_declare_external_prereq ${TEST_EMACSCLIENT}
1181 test_declare_external_prereq ${TEST_GDB}
1182 test_declare_external_prereq gpg
1183 test_declare_external_prereq openssl
1184 test_declare_external_prereq gpgsm
1185 test_declare_external_prereq ${NOTMUCH_PYTHON}